﻿
using System;
using System.Threading.Tasks;
using Wisej.Web;

namespace WebApplication1
{
	public partial class Window1 : Form
	{
		public Window1()
		{
			InitializeComponent();
		}

		private async void button1_Click(object sender, EventArgs e)
		{
			await Application.StartTask(async () =>
			{
				Application.Update(this, () =>
				{
					start.Text = Globals.SESSION_VALUE;
				});

				await Work(); // await for other work

				Application.Update(this, () =>
				{
					end.Text = Globals.SESSION_VALUE ?? "NULL";
				});
			});
		}

		private async Task Work()
		{
			await Application.StartTask(() =>
			{
				Application.Update(this, async () =>
				{
					await this.SetValue(mid, Globals.SESSION_VALUE);
				});
			});

		}

		private async Task SetValue(Label label, string val)
		{
			// other work that can be async
			label.Text = val;
		}
	}
}
